"use strict";
// MIT License
//
// Copyright (c) 2020 Datasert Inc
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.isTimeMatches = exports.getFutureMatches = void 0;
var luxon_1 = require("luxon");
var cronjs_parser_1 = require("@imatis/cronjs-parser");
var MAX_LOOP_COUNT = 100000;
var FLD_SECOND = 'second';
var FLD_MINUTE = 'minute';
var FLD_HOUR = 'hour';
var FLD_DAY_OF_MONTH = 'day_of_month';
var FLD_MONTH = 'month';
var FLD_DAY_OF_WEEK = 'day_of_week';
var FLD_YEAR = 'year';
var DAY_SUN = 0;
var DAY_MON = 1;
var DAY_FRI = 5;
var DAY_SAT = 6;
var FIELD_INFO = (_a = {},
    _a[FLD_SECOND] = {
        min: 0,
        max: 59,
    },
    _a[FLD_MINUTE] = {
        min: 0,
        max: 59,
    },
    _a[FLD_HOUR] = {
        min: 0,
        max: 23,
    },
    _a[FLD_DAY_OF_MONTH] = {
        min: 1,
        max: 31,
    },
    _a[FLD_MONTH] = {
        min: 1,
        max: 12,
    },
    _a[FLD_DAY_OF_WEEK] = {
        min: 0,
        max: 6,
    },
    _a[FLD_YEAR] = {
        min: 1970,
        max: 2099,
    },
    _a);
var TZ_UTC = 'Etc/UTC';
var FIELDS = [FLD_SECOND, FLD_MINUTE, FLD_HOUR, FLD_DAY_OF_MONTH, FLD_MONTH, FLD_YEAR, FLD_DAY_OF_WEEK].reverse();
var FIELDS_SANS_DAY_REVERSE = [FLD_SECOND, FLD_MINUTE, FLD_HOUR, FLD_MONTH, FLD_YEAR].reverse();
// from https://stackoverflow.com/questions/4459928/how-to-deep-clone-in-javascript/
function deepClone(obj) {
    if (!obj) {
        return obj;
    }
    var v;
    var bObject = Array.isArray(obj) ? [] : {};
    for (var k in obj) {
        v = obj[k];
        bObject[k] = typeof v === 'object' ? deepClone(v) : v;
    }
    return bObject;
}
function dedupe(inArray, keySupplier) {
    if (keySupplier === void 0) { keySupplier = function (it) { return it; }; }
    var seen = new Set();
    var deduped = [];
    inArray.forEach(function (x) {
        var keyValue = keySupplier(x);
        if (!seen.has(keyValue)) {
            seen.add(keyValue);
            deduped.push(x);
        }
    });
    return deduped;
}
function sort(values) {
    values.sort(function (a, b) { return a - b; });
    return values;
}
function getWeekDay(time) {
    var weekday = time.weekday;
    return weekday === 7 ? 0 : weekday;
}
function getValues(from, to, step) {
    var values = [];
    for (var i = from; i <= to; i += step) {
        values.push(i);
    }
    return values;
}
function isBlank(values) {
    return !values || values.length === 0;
}
function expandFields(exprs, field, startYear) {
    var values = [];
    exprs.expressions.forEach(function (expr) {
        values.push.apply(values, expandField(expr, field, startYear));
    });
    return values.length === 0 ? values : sort(dedupe(values));
}
function expandField(expr, field, startYear) {
    var exprField = expr[field];
    if (exprField.omit) {
        return field === FLD_SECOND ? [0] : [];
    }
    if (field === FLD_DAY_OF_WEEK) {
        var info_1 = FIELD_INFO[FLD_DAY_OF_MONTH];
        return getValues(info_1.min, info_1.max, 1);
    }
    var info = FIELD_INFO[field];
    var all = exprField.all ||
        exprField.lastDay ||
        exprField.lastWeekday ||
        !isBlank(exprField.lastDays) ||
        !isBlank(exprField.nearestWeekdays) ||
        !isBlank(exprField.nthDays);
    var values = __spreadArrays((exprField.values || []));
    if (all) {
        var from = field == FLD_YEAR ? startYear : info.min;
        values.push.apply(values, getValues(from, info.max, 1));
        return values;
    }
    if (exprField.ranges) {
        exprField.ranges.forEach(function (range) {
            values.push.apply(values, getValues(range.from, range.to, 1));
        });
    }
    if (exprField.steps) {
        exprField.steps.forEach(function (step) {
            values.push.apply(values, getValues(step.from, step.to, step.step));
        });
    }
    if (exprField.steps) {
        exprField.steps.forEach(function (step) {
            values.push.apply(values, getValues(step.from, step.to, step.step));
        });
    }
    return values;
}
function mergeExprs(exprs, startYear) {
    var mergedExpr = {};
    for (var _i = 0, FIELDS_1 = FIELDS; _i < FIELDS_1.length; _i++) {
        var field = FIELDS_1[_i];
        if (field === FLD_DAY_OF_WEEK || field === FLD_DAY_OF_MONTH) {
            continue;
        }
        mergedExpr[field] = {
            values: expandFields(exprs, field, startYear),
        };
    }
    mergedExpr[FLD_DAY_OF_MONTH] = {
        values: sort(dedupe(__spreadArrays(expandFields(exprs, FLD_DAY_OF_MONTH, startYear), expandFields(exprs, FLD_DAY_OF_WEEK, startYear)))),
    };
    return mergedExpr;
}
function simplifyField(expr, field) {
    var exprField = expr[field];
    if (exprField.steps) {
        exprField.values = exprField.values || [];
        exprField.steps.forEach(function (step) {
            var _a;
            (_a = exprField.values).push.apply(_a, getValues(step.from, step.to, step.step));
        });
        delete exprField.steps;
    }
}
function simplifyExprs(exprs) {
    for (var _i = 0, _a = exprs.expressions; _i < _a.length; _i++) {
        var expr = _a[_i];
        for (var _b = 0, FIELDS_2 = FIELDS; _b < FIELDS_2.length; _b++) {
            var field = FIELDS_2[_b];
            simplifyField(expr, field);
        }
    }
    return exprs;
}
function setTime(time, values) {
    return time.set(values);
}
function getTimeSeries(exprs, startTime) {
    var mergedExpr, startMillis, newTime, startTimeReached, _i, _a, year, _b, _c, month, _d, _e, day, _f, _g, hour, _h, _j, minute, _k, _l, second;
    return __generator(this, function (_m) {
        switch (_m.label) {
            case 0:
                mergedExpr = mergeExprs(exprs, startTime.year);
                startMillis = startTime.toMillis();
                newTime = startTime;
                startTimeReached = false;
                _i = 0, _a = mergedExpr[FLD_YEAR].values;
                _m.label = 1;
            case 1:
                if (!(_i < _a.length)) return [3 /*break*/, 14];
                year = _a[_i];
                if (year < startTime.year) {
                    return [3 /*break*/, 13];
                }
                newTime = setTime(newTime, { year: year });
                _b = 0, _c = mergedExpr[FLD_MONTH].values;
                _m.label = 2;
            case 2:
                if (!(_b < _c.length)) return [3 /*break*/, 13];
                month = _c[_b];
                if (year === startTime.year && month < startTime.month) {
                    return [3 /*break*/, 12];
                }
                newTime = setTime(newTime, { month: month });
                _d = 0, _e = mergedExpr[FLD_DAY_OF_MONTH].values;
                _m.label = 3;
            case 3:
                if (!(_d < _e.length)) return [3 /*break*/, 12];
                day = _e[_d];
                if (year === startTime.year && month === startTime.month && day < startTime.day) {
                    return [3 /*break*/, 11];
                }
                if (day > newTime.daysInMonth) {
                    return [3 /*break*/, 11];
                }
                newTime = setTime(newTime, { day: day });
                _f = 0, _g = mergedExpr[FLD_HOUR].values;
                _m.label = 4;
            case 4:
                if (!(_f < _g.length)) return [3 /*break*/, 11];
                hour = _g[_f];
                if (year === startTime.year && month === startTime.month && day === startTime.day && hour < startTime.hour) {
                    return [3 /*break*/, 10];
                }
                newTime = setTime(newTime, { hour: hour });
                _h = 0, _j = mergedExpr[FLD_MINUTE].values;
                _m.label = 5;
            case 5:
                if (!(_h < _j.length)) return [3 /*break*/, 10];
                minute = _j[_h];
                newTime = setTime(newTime, { minute: minute });
                _k = 0, _l = mergedExpr[FLD_SECOND].values;
                _m.label = 6;
            case 6:
                if (!(_k < _l.length)) return [3 /*break*/, 9];
                second = _l[_k];
                newTime = setTime(newTime, { second: second });
                if (!startTimeReached) {
                    if (newTime.toMillis() >= startMillis) {
                        startTimeReached = true;
                    }
                }
                if (!startTimeReached) return [3 /*break*/, 8];
                // console.log(`##### yielding time ${newTime.toISO()}`);
                return [4 /*yield*/, newTime];
            case 7:
                // console.log(`##### yielding time ${newTime.toISO()}`);
                _m.sent();
                _m.label = 8;
            case 8:
                _k++;
                return [3 /*break*/, 6];
            case 9:
                _h++;
                return [3 /*break*/, 5];
            case 10:
                _f++;
                return [3 /*break*/, 4];
            case 11:
                _d++;
                return [3 /*break*/, 3];
            case 12:
                _b++;
                return [3 /*break*/, 2];
            case 13:
                _i++;
                return [3 /*break*/, 1];
            case 14: return [2 /*return*/, undefined];
        }
    });
}
function getLastDay(time, day) {
    var endOfMonth = time.endOf('month');
    var lastDay = endOfMonth.day;
    if (day === undefined) {
        return lastDay;
    }
    while (getWeekDay(endOfMonth) !== day) {
        endOfMonth = endOfMonth.plus({ day: -1 });
    }
    return endOfMonth.day;
}
function getLastWeekDay(time) {
    var endOfMonth = time.endOf('month');
    var lastDay = getWeekDay(endOfMonth);
    if (lastDay >= DAY_MON && lastDay <= DAY_FRI) {
        return endOfMonth.day;
    }
    return getLastDay(time, DAY_FRI);
}
/**
 * Returns all days of particular type in the month. For ex., returns all mondays or fridays etc
 */
function getDaysOfType(time, day) {
    var days = [];
    for (var i = 1; i < 31; i++) {
        var newTime = time.set({ day: i });
        if (newTime.month != time.month) {
            // means it split over to next month
            break;
        }
        if (getWeekDay(newTime) === day) {
            days.push(newTime.day);
        }
    }
    return days;
}
function isWeekday(time) {
    var lastDay = getWeekDay(time);
    return lastDay >= DAY_MON && lastDay <= DAY_FRI;
}
function isDay(time, day) {
    return getWeekDay(time) === day;
}
function setDayWithinMonth(time, day) {
    if (time.daysInMonth < day) {
        day = time.daysInMonth;
    }
    return time.set({ day: day });
}
function isNearestWeekDay(evalTime, day) {
    if (!isWeekday(evalTime)) {
        return false;
    }
    var dayTime = setDayWithinMonth(evalTime, day);
    // if time matches the day, then it is perfect match.
    if (evalTime.day === dayTime.day) {
        return true;
    }
    // if eval time is friday and day is sat, then it is match.
    if (isDay(dayTime, DAY_SAT)) {
        // if sat is first of month, then monday is the match
        if (dayTime.day === 1) {
            return evalTime.day === 3;
        }
        // otherwise friday is match
        return dayTime.day - 1 == evalTime.day;
    }
    if (isDay(dayTime, DAY_SUN)) {
        // if sunday is last day of month, then two days minus sunday is match
        if (dayTime.day === evalTime.daysInMonth) {
            return evalTime.day === evalTime.daysInMonth - 2;
        }
        return dayTime.day + 1 == evalTime.day;
    }
    return false;
}
function isInRange(from, to, value) {
    return value >= from && value <= to;
}
function isFieldMatches(expr, field, timeValue) {
    var value = expr[field];
    if (!value || value.all) {
        return true;
    }
    if (value.omit) {
        // omit in second matches only if second is zero.
        if (field === FLD_SECOND) {
            return timeValue === 0;
        }
        else {
            return false;
        }
    }
    if (value.values && value.values.includes(timeValue)) {
        return true;
    }
    if (value.ranges && value.ranges.find(function (range) { return isInRange(range.from, range.to, timeValue); })) {
        return true;
    }
    return false;
}
function isDayOfMonthMatches(expr, field, time) {
    var info = expr[field];
    if (info.omit) {
        return false;
    }
    // Last week day of month
    if (info.lastWeekday && time.day === getLastWeekDay(time)) {
        return true;
    }
    // last day of month
    if (info.lastDay && time.day === getLastDay(time)) {
        return true;
    }
    if (!isBlank(info.nearestWeekdays) &&
        info.nearestWeekdays.find(function (day) { return isNearestWeekDay(time, day); }) !== undefined) {
        return true;
    }
    // finally we will do usual values check
    return isFieldMatches(expr, field, time.day);
}
function isDayOfWeekMatches(expr, field, time) {
    var info = expr[field];
    if (info.omit) {
        return false;
    }
    if (info.lastDay && getWeekDay(time) === DAY_SAT) {
        return true;
    }
    if (!isBlank(info.lastDays) && info.lastDays.find(function (day) { return time.day === getLastDay(time, day); }) !== undefined) {
        // Last day of kind
        return true;
    }
    // nth day
    if (!isBlank(info.nthDays)) {
        if (info.nthDays.find(function (nthDay) {
            var days = getDaysOfType(time, nthDay.day_of_week);
            return days.length > nthDay.instance && days[nthDay.instance - 1] === time.day;
        }) !== undefined) {
            return true;
        }
    }
    // finally we will do usual values check
    return isFieldMatches(expr, field, getWeekDay(time));
}
function isExprMatches(expr, startTime) {
    for (var _i = 0, FIELDS_SANS_DAY_REVERSE_1 = FIELDS_SANS_DAY_REVERSE; _i < FIELDS_SANS_DAY_REVERSE_1.length; _i++) {
        var field = FIELDS_SANS_DAY_REVERSE_1[_i];
        // @ts-ignore
        if (!isFieldMatches(expr, field, startTime[field])) {
            return false;
        }
    }
    // Now all all easy part of the date matches, now is the time to evaluate complicated day field
    return isDayOfMonthMatches(expr, FLD_DAY_OF_MONTH, startTime) || isDayOfWeekMatches(expr, FLD_DAY_OF_WEEK, startTime);
}
function isExprsMatches(exprs, time) {
    return exprs.expressions.find(function (expr) { return isExprMatches(expr, time); }) !== undefined;
}
function getOutputTime(newTime, options) {
    if (options.formatInTimezone) {
        return newTime.toISO({ suppressMilliseconds: true });
    }
    else {
        return newTime.setZone(TZ_UTC).toISO({ suppressMilliseconds: true, includeOffset: false }) + "Z";
    }
}
/**
 * Evaluates the parsed cron expression and returns the run times.
 * Note that it is assumed that cron expression is parsed using @datasert/cron-parser. Otherwise the results
 * are undefined.
 */
function getFutureMatches(expr, options) {
    if (options === void 0) { options = {}; }
    var dtoptions = { zone: options.timezone || TZ_UTC };
    var startTime = luxon_1.DateTime.fromISO(options.startAt ? options.startAt : new Date().toISOString(), dtoptions);
    var endTime = options.endAt ? luxon_1.DateTime.fromISO(options.endAt, dtoptions) : undefined;
    var count = options.matchCount || 5;
    var nextTimes = [];
    var cronExprs = simplifyExprs(typeof expr === 'string' ? cronjs_parser_1.parse(expr) : deepClone(expr));
    var timeSeries = getTimeSeries(cronExprs, startTime);
    var maxLoopCount = options.maxLoopCount || MAX_LOOP_COUNT;
    var loopCount = 0;
    while (loopCount < maxLoopCount) {
        loopCount++;
        var newTime = timeSeries.next().value;
        if (!newTime || (endTime && newTime.toMillis() >= endTime.toMillis())) {
            break;
        }
        if (newTime.toMillis() < startTime.toMillis()) {
            continue;
        }
        // console.log('####### checking time', newTime.toISO());
        if (isExprsMatches(cronExprs, newTime)) {
            var time = getOutputTime(newTime, options);
            var matchOk = options.matchValidator ? options.matchValidator(time) : true;
            if (matchOk) {
                nextTimes.push(time);
            }
        }
        if (nextTimes.length >= count) {
            break;
        }
    }
    return nextTimes;
}
exports.getFutureMatches = getFutureMatches;
function isTimeMatches(exprs, time, timezone) {
    var cronExprs = simplifyExprs(typeof exprs === 'string' ? cronjs_parser_1.parse(exprs) : deepClone(exprs));
    var startTime = luxon_1.DateTime.fromISO(time, { zone: timezone || TZ_UTC });
    return isExprsMatches(cronExprs, startTime);
}
exports.isTimeMatches = isTimeMatches;
//# sourceMappingURL=matcher.js.map